aboutsummaryrefslogtreecommitdiff
path: root/contrib
diff options
context:
space:
mode:
Diffstat (limited to 'contrib')
-rwxr-xr-xcontrib/kiss-chbuild34
1 files changed, 34 insertions, 0 deletions
diff --git a/contrib/kiss-chbuild b/contrib/kiss-chbuild
new file mode 100755
index 0000000..69e0854
--- /dev/null
+++ b/contrib/kiss-chbuild
@@ -0,0 +1,34 @@
+#!/bin/sh -e
+#
+# Create/destroy temporary chroots.
+
+log() {
+ printf '\033[31;1m->\033[m %s.\n' "$@"
+}
+
+clean() {
+ log "Destroying chroot"
+ su -c "rm -rf chroot-$pid" || clean
+}
+
+pid=$$
+
+cd "${cac_dir:=$KISS_ROOT${XDG_CACHE_HOME:-$HOME/.cache}/kiss}"
+
+[ -f kiss-chroot.tar.xz ] || {
+ log "Downloading chroot tarball"
+ wget https://dl.getkiss.org/kiss-chroot.tar.xz
+}
+
+[ -d kiss-chroot ] || {
+ log "Extracting chroot"
+ tar xvf kiss-chroot.tar.xz
+}
+
+log "Creating temporary chroot"
+cp -a kiss-chroot "chroot-$pid"
+
+trap clean EXIT INT
+
+log "Entering chroot"
+su -c "kiss-chroot chroot-$pid"